package com.adbc.qtracker;

import android.content.Context;

import androidx.annotation.NonNull;

import com.adbc.tracker.ADBCTracker;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class QTrackerPlugin implements MethodChannel.MethodCallHandler, FlutterPlugin, ActivityAware {

    private Context mContext;
    private MethodChannel mMethodChannel;

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {

        switch (call.method) {
            case "init":
                ADBCTracker.init(mContext);
                result.success(null);
                break;
            case "sendOpen":
                ADBCTracker.sendOpen(mContext);
                result.success(null);
                break;
            case "sendEvent":
                ADBCTracker.sendEvent(mContext, call.argument("event_name"));
                result.success(null);
                break;
            default:
                result.notImplemented();
                break;
        }
    }

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding binding) {
        mContext = binding.getApplicationContext();
        mMethodChannel = new MethodChannel(binding.getBinaryMessenger(), "qtracker");
        mMethodChannel.setMethodCallHandler(this);
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        mMethodChannel.setMethodCallHandler(null);
        mMethodChannel = null;
    }

    @Override
    public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {
    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
    }

    @Override
    public void onDetachedFromActivity() {
    }
}
